#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static char ext_tbl[] = ".118.HMM.OPI.OVI.SE";



static unsigned int get_word(unsigned char *p){
	unsigned int t;
	t = p[1];
	t = ((t << 8) | p[0]);
	return t;
}

static unsigned long get_dword(unsigned char *p){
	unsigned long t;
	t = p[3];
	t = ((t << 8) | p[2]);
	t = ((t << 8) | p[1]);
	t = ((t << 8) | p[0]);
	return t;
}



static int expand(unsigned char *dest, long dest_size, unsigned char *src, long src_size){
	long d_ofs, ofs, t_ofs;

	int ax, cx;
	int dl, dh;
	int cf;
	int t_cx;



	d_ofs = 0;
	ofs = 0;

	dh = 1;


L060c:
	cx = -1;
L0610:
	cx += 1;
	dh -= 1;
	if(dh != 0) goto L0625;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L0625:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	if(cf != 0) goto L0610;

	ax = 1;
	if(cx == 0) goto L0648;
L062e:
	dh -= 1;
	if(dh != 0) goto L0642;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L0642:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	ax <<= 1; ax |= cf;
	cx -= 1; if(cx != 0) goto L062e;

L0648:
	cx = ax;
L064d:
	dest[d_ofs] = src[ofs]; d_ofs += 1; ofs += 1;
	cx -= 1; if(cx != 0) goto L064d;

L065b:
	if(d_ofs < dest_size) goto L0664;
	goto L0709;


L0664:
	cx = -1;
L0668:
	cx += 1;
	dh -= 1;
	if(dh != 0) goto L067d;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L067d:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	if(cf != 0) goto L0668;

	ax = 1;
	if(cx == 0) goto L06a0;
L0686:
	dh -= 1;
	if(dh != 0) goto L069a;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L069a:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	ax <<= 1; ax |= cf;
	cx -= 1; if(cx != 0) goto L0686;
L06a0:
	cx = ax;


L06a2:
	t_cx = cx;
	cx = -1;
L06a7:
	cx += 1;
	dh -= 1;
	if(dh != 0) goto L06bc;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L06bc:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	if(cf != 0) goto L06a7;

	ax = 1;
	if(cx == 0) goto L06df;
L06c5:
	dh -= 1;
	if(dh != 0) goto L06d9;
	dl = src[ofs]; ofs += 1;
	dh = 8;
L06d9:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	ax <<= 1; ax |= cf;
	cx -= 1; if(cx != 0) goto L06c5;

L06df:
	cx = t_cx;
	t_ofs = (d_ofs - ax);
	memcpy((dest + d_ofs), (dest + t_ofs), cx);
	d_ofs += cx;
	if(d_ofs >= dest_size) goto L0709;

L06eb:
	dh -= 1;
	if(dh != 0) goto L06ff;
	dl = src[ofs]; ofs += 1;
	dh = 8;

L06ff:
	cf = ((dl & 0x80) ? 1 : 0); dl <<= 1;
	if(cf == 0) goto L0706;
	goto L0664;

L0706:
	goto L060c;

L0709:


	return d_ofs;
}







int main(int argc, char *argv[]){
	char *src_name;
	FILE *fi, *fo;
	unsigned char *tbl;
	long dac_size, dac_ofs;
	long size, ofs;
	unsigned char *buf;
	int flag;

	src_name = NULL;
	flag = 0;

	{
		int k;
		for(k = 1; k < argc; ++k){
			if((argv[k][0] != '/') && (argv[k][0] != '-')){
				if(NULL == src_name){
					src_name = argv[k];
				}
				continue;
			}
			switch(argv[k][1]){
				case 'E':
				case 'e':
					flag &= ~0x01;
					break;

				case 'S':
				case 's':
					flag |= 0x01;
					break;

				case 'A':
				case 'a':
					flag &= ~0x10;
					break;

				case 'M':
				case 'm':
					flag |= 0x10;
					break;
			}
		}
	}


	if(NULL == src_name){
		exit(0);
	}


	fi = fopen(src_name, "rb");
	if(NULL == fi){
		printf("t@C݂܂ (%s\n", src_name);
		exit(1);
	}

	tbl = malloc(0x2000);
	if(NULL == tbl){
		fclose(fi);
		printf("܂ (%s\n", src_name);
		exit(1);
	}
	fread(tbl, 1, 0x2000, fi);

	ofs = 0;
	while(0x2000 > ofs){
		if(0 == get_dword(tbl + ofs + 12)){
			ofs += 16;
			break;
		}
		ofs += 16;
	}
	if(0x2000 <= ofs){
		free(tbl);
		fclose(fi);
		printf("DAC ł͂܂ (%s\n", src_name);
		exit(1);
	}
	dac_ofs = ofs;

	fseek(fi, 0, SEEK_END);
	dac_size = ftell(fi);
	fseek(fi, dac_ofs, SEEK_SET);

	puts("   name       offset  size    exp size");
	puts("=========================================");

	ofs = 0;
	while(1){
		size = get_dword(tbl + ofs + 12);
		if(0 == size){
			break;
		}
		dac_ofs += size;
		if(dac_size <= dac_ofs){
			break;
		}
		tbl[ofs + 12] = 0;

		if(0 != (flag & 0x10)){
			char *p;
			p = strrchr((tbl + ofs), '.');
			if((NULL == p) || (NULL == strstr(ext_tbl, p))){
				fseek(fi, size, SEEK_CUR);
				ofs += 16;
				continue;
			}
		}

		printf("%-12s  %06x  %-6d  ", (tbl + ofs), (dac_ofs - size), size);

		buf = malloc(size);
		if(NULL == buf){
			free(tbl);
			fclose(fi);
			printf("܂ (%s\n", src_name);
			exit(1);
		}
		fread(buf, 1, size, fi);

		if((0 == (flag & 0x01)) && (0x5043 == get_word(buf))){
			long t_size, t_ofs;
			unsigned char *t_buf;
			t_size = get_word(buf + 2);
			printf("%-d\n", t_size);
			t_buf = malloc(t_size);
			if(NULL == t_buf){
				free(buf);
				free(tbl);
				fclose(fi);
				printf("܂ (%s\n", src_name);
				exit(1);
			}
			t_size = expand(t_buf, t_size, (buf + 4), (size - 4));
			free(buf);
			buf = t_buf;
			size = t_size;
		}
		else{
			puts("------");
		}

		fo = fopen((tbl + ofs), "wb");
		fwrite(buf, 1, size, fo);
		fclose(fo);

		free(buf);

		ofs += 16;
	}

	puts("=========================================");

	free(tbl);
	fclose(fi);

	exit(0);
}
